package com.perf.nio;
import java.util.*;
import java.io.*;
import com.perf.timer.*;
public class BasicIOReadUtil {
	public static void main(String args[]) throws Exception{
		String fileName="Dummy.txt";//а ϴ ϸ  ġ ϼ. 
		StopWatch sw=new StopWatch();
		
		sw.start();
		Vector v1=BasicIOReadUtil.readCharStream(fileName);
		System.out.println(sw);
		System.out.println(v1.size());
		
		sw.start();
		String str=BasicIOReadUtil.readCharStreamWithBuffer(fileName);
		System.out.println(sw);
		System.out.println(str.length());
		
		sw.start();
		Vector v2=BasicIOReadUtil.readBufferedReader(fileName);
		System.out.println(sw);
		System.out.println(v2.size());
		
	}
	
	public static Vector readCharStream(String fileName) throws Exception{
		Vector<StringBuffer> v=new Vector<StringBuffer>();
		FileReader fr=null;
		try {
			fr=new FileReader(fileName);
			int data=0;
			StringBuffer sb=new StringBuffer();
			while((data=fr.read())!=-1) {
				if(data=='\n' || data=='\r') {
					v.addElement(sb);
					sb=new StringBuffer();
				} else {
					sb.append((char)data);
				}
			}
		} catch (IOException e) {
			System.err.println(e.getMessage());
			throw e;
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			if(fr!=null) fr.close();
		}
		return v;
	}
	public static String readCharStreamWithBuffer(String fileName) throws Exception{
		StringBuffer retSB=new StringBuffer();
		FileReader fr=null;
		try {
			fr=new FileReader(fileName);
			int bufferSize=1024*1024;
			char readBuffer[]=new char[bufferSize];
			int resultSize=0;
			
			while((resultSize=fr.read(readBuffer))!=-1) {
				if(resultSize==bufferSize) {
					retSB.append(readBuffer);
				} else {
					for(int loop=0;loop<resultSize;loop++) {
						retSB.append(readBuffer[loop]);
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			if(fr!=null) fr.close();
		}
		return retSB.toString();
	}
	public static Vector<String> readBufferedReader(String fileName) throws Exception{
		Vector<String> v=new Vector<String>();
		BufferedReader br=null;
		try {
			br=new BufferedReader(new FileReader(fileName));
			String data;
			while((data=br.readLine())!=null) {
				v.addElement(data);
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			if(br!=null) br.close();
		}
		return v;
	}
	
}
